/* Tabela INSPECPROD*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela INSPECPROD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela INSPECPROD, utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_CDP_INSPECPROD
AFTER DELETE OR INSERT OR UPDATE
ON INSPECPROD FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_NRINCREST    := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

      IF INSERTING THEN 

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;
         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;
         IF :NEW.NRSEQINSPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Sequencial = ' || NVL(:NEW.NRSEQINSPRO,'') || ' ';
         END IF;
         IF :NEW.IDIMPINSPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Impeditiva = ' || NVL(:NEW.IDIMPINSPRO,'') || ' ';
         END IF;
         IF :NEW.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Setor = ' || NVL(:NEW.CDSETOR,'') || ' ';
         END IF;
         IF :NEW.IDPROCPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Material = ' || NVL(:NEW.IDPROCPROD,'') || ' ';
         END IF;
         IF :NEW.DTULTATUINPR IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:NEW.DTULTATUINPR,'') || ' ';
         END IF;
         IF :NEW.IDSTATUSINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Situao = ' || NVL(:NEW.IDSTATUSINSPEC,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDPRODUTO || :NEW.CDINSPECAO || :NEW.NRSEQINSPRO;
         V_IDTIPOOPER := '1';

   ELSE

      IF UPDATING THEN

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;
         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;
         IF :NEW.NRSEQINSPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Sequencial = ' || NVL(:NEW.NRSEQINSPRO,'') || ' ';
         END IF;
         IF :NEW.IDIMPINSPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Impeditiva = ' || NVL(:NEW.IDIMPINSPRO,'') || ' ';
         END IF;
         IF :NEW.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Setor = ' || NVL(:NEW.CDSETOR,'') || ' ';
         END IF;
         IF :NEW.IDPROCPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Material = ' || NVL(:NEW.IDPROCPROD,'') || ' ';
         END IF;
         IF :NEW.DTULTATUINPR IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:NEW.DTULTATUINPR,'') || ' ';
         END IF;
         IF :NEW.IDSTATUSINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Situao = ' || NVL(:NEW.IDSTATUSINSPEC,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDPRODUTO || :NEW.CDINSPECAO || :NEW.NRSEQINSPRO;
         V_IDTIPOOPER := '2';

      END IF;

      IF DELETING  THEN

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:OLD.CDPRODUTO,'') || ' ';
         END IF;
         IF :OLD.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:OLD.CDINSPECAO,'') || ' ';
         END IF;
         IF :OLD.NRSEQINSPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Sequencial = ' || NVL(:OLD.NRSEQINSPRO,'') || ' ';
         END IF;
         IF :OLD.IDIMPINSPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Impeditiva = ' || NVL(:OLD.IDIMPINSPRO,'') || ' ';
         END IF;
         IF :OLD.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Setor = ' || NVL(:OLD.CDSETOR,'') || ' ';
         END IF;
         IF :OLD.IDPROCPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Material = ' || NVL(:OLD.IDPROCPROD,'') || ' ';
         END IF;
         IF :OLD.DTULTATUINPR IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:OLD.DTULTATUINPR,'') || ' ';
         END IF;
         IF :OLD.IDSTATUSINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Situao = ' || NVL(:OLD.IDSTATUSINSPEC,'') || ' ';
         END IF;

         V_ITPESQ     := :OLD.CDPRODUTO || :OLD.CDINSPECAO || :OLD.NRSEQINSPRO;
         V_IDTIPOOPER := '3';

      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA,     DTOPERACAO,   NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,   CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER,  CDFILLOGOPER)
                       VALUES  ('INSPECPROD', SYSDATE,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                                V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                                V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_INSPECPROD','5.85.xxx'); END;
/
